package jogo;

import java.awt.Graphics;
import java.awt.Image;
import java.awt.Rectangle;
import javax.swing.ImageIcon;

public abstract class Elemento {

    protected Principal jogo;
    protected Image icone;
    protected String imageNome;
    protected int x, y, ID;
    protected int largura, altura;
    protected int linha, coluna;
    public final int deslocamento = 20;
    protected boolean altitude;

    public Elemento(Principal jogo, String imageNome, int px, int py) {
        this.jogo = jogo;
        this.imageNome = imageNome;
        this.altitude = true;
        this.icone = this.carregaImagem(this.imageNome + ".png");
        this.largura = this.icone.getWidth(null);
        this.altura = this.icone.getHeight(null);
        this.x = px * this.deslocamento;
        this.y = py * this.deslocamento;
    }

    public int getID() {
        return ID;
    }

    public boolean isAltitude() {
        return altitude;
    }

    public void desenhar(Graphics g) {
        g.drawImage(this.icone, this.x, this.y, this.jogo);
    }

    public final Image carregaImagem(String imagem) {
        ImageIcon icon = new ImageIcon(this.getClass().getResource("/imagens/" + imagem));

        return icon.getImage();
    }

    public boolean colidiu(Rectangle r) {
        return r.intersects(this.obtemRectangle());
    }

    public Rectangle obtemRectangle() {
        return new Rectangle(this.x, this.y, this.largura, this.altura);
    }

    public abstract void atualizar();
    
    public int getAltura() {
        return altura;
    }

    public int getLargura() {
        return largura;
    }

    public int getX() {
        return this.x/this.deslocamento;
    }

    public int getY() {
        return this.y/this.deslocamento;
    }
    
    
}
