package jogo;

import java.awt.Graphics;

public class Jogador extends Elemento {

    private int cima, baixo, direita, esquerda, atirar, direcao;
    private int pontos, combustivel, vidas, tempoMorto, qtdPisca, tempoTiro, tempoComb;
    private boolean estado;
    private String nome;

    public Jogador(Principal jogo, String imageNome, int px, int py, int cima, int baixo, int direita, int esquerda, int atirar, String nome, int j) {
        super(jogo, imageNome, px, py);
        this.cima = cima;
        this.baixo = baixo;
        this.direita = direita;
        this.esquerda = esquerda;
        this.atirar = atirar;
        this.nome = nome;
        super.ID = j;
        this.vidas = 3;
        this.pontos = 0;
        this.estado = true;
        this.tempoMorto = 0;
        this.qtdPisca = 10;
        this.combustivel = 100;
        this.tempoTiro = 0;
        this.tempoComb = 0;
    }

    @Override
    public void atualizar() {
        if (this.jogo.teclado.teclaApertada(this.cima)) {
            super.altitude = true;
            tempoTiro++;
        }
        if (this.jogo.teclado.teclaApertada(this.baixo)) {
            this.altitude = false;
            tempoTiro++;

        }
        if (this.jogo.teclado.teclaApertada(this.direita)) {
            this.direcao = 1;
            this.x -= super.deslocamento;
            tempoTiro++;
        }
        if (this.jogo.teclado.teclaApertada(this.esquerda)) {
            this.direcao = 2;
            this.x += super.deslocamento;
            tempoTiro++;
        }
        if (this.jogo.teclado.teclaApertada(this.atirar)) {
            tempoTiro++;
            if ((tempoTiro % 3 == 0) && (estado)) {
                ((Tela) this.jogo.jPtela).tiro.add(new Tiro(((Tela) this.jogo.jPtela).principal, "tiro" + this.ID,
                        (this.x / this.deslocamento), 22, super.ID, this.altitude, this.largura));
                tempoTiro = 0;
            }
        }
        this.atualizarCombustivel(0);

    }

    @Override
    public void desenhar(Graphics g) {
        if (this.estado == true) {
            if (this.altitude) {
                if (this.direcao == 0) {
                    this.icone = this.carregaImagem(this.imageNome + ".png");
                    g.drawImage(this.icone, this.x, this.y, this.jogo);
                } else if (direcao == 1) {
                    this.icone = this.carregaImagem(this.imageNome + "_cd.png");
                    g.drawImage(this.icone, this.x, this.y, this.jogo);
                    this.direcao = 0;
                } else if (direcao == 2) {
                    this.icone = this.carregaImagem(this.imageNome + "_ce.png");
                    g.drawImage(this.icone, this.x, this.y, this.jogo);
                    this.direcao = 0;
                }
            } else {
                if (this.direcao == 0) {
                    this.icone = this.carregaImagem(this.imageNome + "_b.png");
                    g.drawImage(this.icone, this.x, this.y, this.jogo);
                } else if (direcao == 1) {
                    this.icone = this.carregaImagem(this.imageNome + "_bd.png");
                    g.drawImage(this.icone, this.x, this.y, this.jogo);
                    this.direcao = 0;
                } else if (direcao == 2) {
                    this.icone = this.carregaImagem(this.imageNome + "_be.png");
                    g.drawImage(this.icone, this.x, this.y, this.jogo);
                    this.direcao = 0;
                }
            }
        } else {
            this.tempoMorto++;
            if (this.tempoMorto % 2 == 0) {
                if (this.altitude) {
                    if (this.direcao == 0) {
                        this.icone = this.carregaImagem(this.imageNome + ".png");
                        g.drawImage(this.icone, this.x, this.y, this.jogo);
                        this.qtdPisca++;
                        if (qtdPisca >= 10) {
                            estado = true;
                        }
                        this.tempoMorto = 0;
                    } else if (direcao == 1) {
                        this.icone = this.carregaImagem(this.imageNome + "_cd.png");
                        g.drawImage(this.icone, this.x, this.y, this.jogo);
                        this.direcao = 0;
                        this.qtdPisca++;
                        if (qtdPisca >= 10) {
                            estado = true;
                        }
                        this.tempoMorto = 0;
                    } else if (direcao == 2) {
                        this.icone = this.carregaImagem(this.imageNome + "_ce.png");
                        g.drawImage(this.icone, this.x, this.y, this.jogo);
                        this.direcao = 0;
                        this.qtdPisca++;
                        if (qtdPisca >= 10) {
                            estado = true;
                        }
                        this.tempoMorto = 0;
                    }
                } else {
                    if (this.direcao == 0) {
                        this.icone = this.carregaImagem(this.imageNome + "_b.png");
                        g.drawImage(this.icone, this.x, this.y, this.jogo);
                        this.qtdPisca++;
                        if (qtdPisca >= 10) {
                            estado = true;
                        }
                        this.tempoMorto = 0;
                    } else if (direcao == 1) {
                        this.icone = this.carregaImagem(this.imageNome + "_bd.png");
                        g.drawImage(this.icone, this.x, this.y, this.jogo);
                        this.direcao = 0;
                        this.qtdPisca++;
                        if (qtdPisca >= 10) {
                            estado = true;
                        }
                        this.tempoMorto = 0;
                    } else if (direcao == 2) {
                        this.icone = this.carregaImagem(this.imageNome + "_be.png");
                        g.drawImage(this.icone, this.x, this.y, this.jogo);
                        this.direcao = 0;
                        this.qtdPisca++;
                        if (qtdPisca >= 10) {
                            estado = true;
                        }
                        this.tempoMorto = 0;
                    }
                }
            }
        }
    }

    public int atualizarPontos(int p) {
        return this.pontos += p;
    }

    public void atualizarCombustivel(int c) {
        this.tempoComb++;
        if (this.tempoComb % 5 == 0) {
            this.combustivel -= 2;
            if (this.combustivel <= 0) {
                this.jogo.atualizarVidas(this.ID, this.atualizarVidas());
            }
            this.tempoComb = 0;
        }
        
        if (this.combustivel + c <= 100) {
            this.combustivel += c;
        } else {
            this.combustivel = 100;
        }

    }

    public int atualizarVidas() {
        if (this.qtdPisca >= 10) {
            this.qtdPisca = 0;
            this.estado = false;
            this.combustivel = 100;
            return --this.vidas;
        }
        return this.vidas;
    }

    public int getCombustivel() {
        return combustivel;
    }

    public String getNome() {
        return nome;
    }

    public int getPontos() {
        return pontos;
    }
    
    
}
